/**
 Trivial UNIX fork() program.
 Orion Sky Lawlor, olawlor@acm.org, 2005/2/7 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h> /* for "fork" */
#include <sys/wait.h> /* for "waitpid" */

enum {runTimes=20, delayLen=10*1000*1000};
int total=0;
void run(void *ptr) {
	int threadNo=*(int *)ptr;
	for (int n=0;n<runTimes;n++) {
		for (int i=0;i<delayLen;i++) {}
		printf("%c: (it %d)  (total %d)\n",'A'+threadNo,n,total);
		fflush(stdout);
		total++;
	}
}

int main() {
	pid_t child=fork();
	if (child==0) { /* I'm the child process */
		int threadNo=1;
		run(&threadNo);
		printf("child total is %d\n",total);
	} else { /* child!=0, so I'm the parent process */
		int threadNo=0;
		run(&threadNo);
		waitpid(child,0,0); /* wait for child to exit */
		printf("parent total is %d\n",total);
	}
	return 0;
}
